// Java-Rechenbaum-Programm, fr IF12M  -- Krell, 19.7.04   (www.r-krell.de)

import java.awt.*;
import java.awt.event.*;

public class Rb_Oberflaeche extends Frame
// Grafische Oberflche zum Testen des Baum 
{
  TextField eingabe = new TextField("",19);
  TextArea ausgabe = new TextArea("Bitte Rechenterm wie 3+6-8*9/2*1 eingeben und dann \"Term->Baum\" drcken!\n",16,88);
  Button knBaum, knTerm, knErgebnis, knStruktur; // Knpfe definieren

  Rb_Rechenbaum baum = new Rb_Rechenbaum();
    
  public void richteFensterEin() // Fenster initalisieren und beschreiben
  {
    //WindowsListener hinzufgen, damit Schlieknopf funktioniert
    addWindowListener (    
      new WindowAdapter ()
      {
        public void windowClosing (WindowEvent ereignis)
        {                
          setVisible (false);
          dispose();
          System.exit(0);
        }
      }
    ); // runde Klammer vom Windowlistener geschlossen;  
    
    setTitle("Test von Rechenbumen   -- IF12M, 20.7.2004 --  www.r-krell.de"); // Fenster mit Titel versehen
    setSize (660,325); // Fenstergre (Breite und Hhe in Pixeln) festlegen
    setLayout (new FlowLayout()); 
  }  
   
  public void richteKnpfeEin()
  {     
    // Knpfe erzeugen:
    knBaum     = new Button ("Term -> Baum");
    knTerm     = new Button ("Baum -> Term");
    knErgebnis = new Button ("Baum -> Ergebnis");
    knStruktur = new Button ("Baumstruktur zeigen");

    //Funktion der Knpfe festlegen:

    knBaum.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {
          String ein = eingabe.getText();
          eingabe.requestFocus();
          if (ein.equals(""))
          {
            ausgabe.append ("** Erst Term eingeben, der verwandelt werden soll! **\n");
          }
          else
          {
            eingabe.requestFocus();
            //eingabe.selectAll();
            ausgabe.append ("Eingegebener Term: "+ein+"\n" +baum.term2Baum(ein));
          }
        }
      });

    knTerm.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          //eingabe.selectAll();
          ausgabe.append ("Ermittelter Term: "+baum.baum2Term()+"\n");
        }
      }); 
        
    knErgebnis.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          //eingabe.selectAll();
          ausgabe.append ("Berechntes Ergebnis: "+baum.baum2Ergebnis()+"\n");
        }   
      });

    knStruktur.addActionListener (
      new ActionListener ()
      {
        public void actionPerformed (ActionEvent e)
        {        
          eingabe.requestFocus();
          eingabe.selectAll();
          ausgabe.append (baum.zeigeStruktur());
        }   
      });   

  } // richteKnpfeEin
   
  public void fhreAus ()
  { 
    richteFensterEin();        
    richteKnpfeEin();    
    ausgabe.setEditable(false); // Ausgabe nicht vom Benutzer nderbar
    ausgabe.setFont(new Font("Monospaced", 0, 12));
    
    add (eingabe); add (knBaum); add (knTerm); add (knErgebnis);
    // add (knStruktur);
    add (ausgabe);
    setVisible(true);
    eingabe.requestFocus();
  }   
}
